# Setup

Install the requirements with `pip install -r requirements.txt` 


## Max Mining Process
Run the scripts in `data_retrieval/max`

We perform manual analysis of issues after running all the scripts

## Pure Data Mining Process
We mine the Pure Data externals library "Deken" for possible git repositories since the git repositories are not explicitly given. To perform our search, we perform the following steps:
1. Extract the list of external library names from https://deken.puredata.info/search.json (232 results as of March 23, 2023)
2. For each library name perform a Google search with the phrase \qq{\textlangle library name\textrangle git pure data}
3. Manually evaluate the Google search results to determine if there is a git repository for the library, during manual evaluation we also note any interesting observations of our search

Using the manually curated list of respositories, we run the scripts in `data_retrieval/puredata`

We perform a manual analysis of issues after running all the scripts

## Generating scripts for manual verification
Run the Python scripts in validation and pipe the output of each script to see output of szz

```sh
python generate_validation_max_csv.py > max_verification_ouput.txt
python generate_validation_pd_csv.py > max_verification_ouput.txt
```