from github import Github # PyGithub 
import pandas as pd
from datetime import datetime

g = Github("<GITHUB TOKEN>")

search_time = datetime.now().strftime("%Y_%m_%d-%I_%M_%S_%p")
issues = g.search_issues("label:bug language:Max state:closed reason:completed type:issue")

serialized_issues = []

for i in issues:
    # Iterate thorugh Issue objects
    # https://pygithub.readthedocs.io/en/latest/github_objects/Issue.html
    serialized_issues.append({
        'repository': i.repository.html_url,
        'html_url': i.html_url,
        'title': i.title,
        'description': i.body,
        'num_comments': i.comments,
        'closed_at': i.closed_at,
        'created_at': i.created_at,
        'updated_at': i.updated_at,
        'labels': ', '.join([x.name for x in i.labels]),
        'number': i.number,
        'state': i.state,
        'user': i.user.html_url,
        'locked': i.locked,
        'active_lock_reason': i.active_lock_reason
    })

pd.DataFrame(serialized_issues).to_csv(f'maxpat_issues_{search_time}_pd_backup.csv', index=False)

df = pd.DataFrame(serialized_issues)
if 'description' in df.columns:
    del df['description']

df.to_csv(f'maxpat_issues_{search_time}.csv', index=False)