from github import Github # PyGithub 
import pandas as pd
from datetime import datetime
import time
import calendar

g = Github("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")

df = pd.read_csv('deken_annotation_git_repos.csv')

search_time = datetime.now().strftime("%Y_%m_%d-%I_%M_%S_%p")

skipped_urls = []
serialized_issues = []
seen_before = []

# https://github.com/PyGithub/PyGithub/issues/553#issuecomment-501386491
def api_wait_search(git):
  limits = git.get_rate_limit()
  if limits.search.remaining <= 2:
    seconds = limits.search.reset.timestamp() - datetime.utcnow().timestamp() + 2
    print("Waiting for %d seconds search ..." % (seconds))
    time.sleep(seconds)

def api_wait_core(git):
  limits = git.get_rate_limit()
  if limits.core.remaining <= 2:
    seconds = limits.core.reset.timestamp() - datetime.utcnow().timestamp() + 2
    print("Waiting for %d seconds core ..." % (seconds))
    time.sleep(seconds)

def extract_issues_from_repo(url):
    if 'https://github.com' in url and '/tree/' not in url and url not in seen_before:
        seen_before.append(url)
        repo_name = '/'.join(url.split('/')[-2:])

        issues = g.search_issues(f"state:closed reason:completed type:issue repo:{repo_name}")
        print(f"state:closed reason:completed type:issue repo:{repo_name}")

        api_wait_search(g)
        api_wait_core(g)
                
        for i in issues:
            api_wait_search(g)
            api_wait_core(g)
            # Iterate thorugh Issue objects
            # https://pygithub.readthedocs.io/en/latest/github_objects/Issue.html
            serialized_issues.append({
                'repository': i.repository.html_url,
                'html_url': i.html_url,
                'title': i.title,
                'description': i.body,
                'num_comments': i.comments,
                'closed_at': i.closed_at,
                'created_at': i.created_at,
                'updated_at': i.updated_at,
                'labels': ', '.join([x.name for x in i.labels]),
                'number': i.number,
                'state': i.state,
                'user': i.user.html_url,
                'locked': i.locked,
                'active_lock_reason': i.active_lock_reason
            })
    else:
        skipped_urls.append({
            'skipped': url
        })

df[df['git_repo'].notnull()]['git_repo'].apply(extract_issues_from_repo)

pd.DataFrame(serialized_issues).to_csv(f'pd_issues_{search_time}_pd_backup.csv', index=False)

df = pd.DataFrame(serialized_issues)
if 'description' in df.columns:
    del df['description']

df.to_csv(f'pd_issues_{search_time}.csv', index=False)

pd.DataFrame(skipped_urls).to_csv(f'pd_issues_{search_time}_skipped_urls.csv', index=False)